﻿using System.Collections.ObjectModel;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Input;
using System.Windows.Media;
using Syncfusion.UI.Xaml.Charts;
using System;
using System.Collections.Generic;
using System.Windows;
using Syncfusion.Windows.SampleLayout;
using Syncfusion.Windows.Shared;

namespace WPF
{
    public partial class MainWindow
    {
        
        public MainWindow()
        {
            InitializeComponent();

            
        }
    }

    public class ViewModel
    {

        public DataTemplate labelTemplate;
        private readonly Random _rnd = new Random();
        public ChartSeriesCollection Series { get; set; }
        public ICommand BuildPieCommand
        {
            get { return new DelegateCommand<object>(DoSomething); }
        }

        private void DoSomething(object instance)
        {
            BuildPie();
        }

        public ViewModel()
        {
            Series = new ChartSeriesCollection();
        }

        private void BuildPie()
        {
            Series.Clear();
            var n = _rnd.Next(2, 5);
            for (int i = 1; i <= n; i++)
            {
                var adornment = new ChartAdornmentInfo();
                adornment.SegmentLabelContent = LabelContent.YValue;
                adornment.ShowLabel = true;
                adornment.UseSeriesPalette = true;
                //adornment.ShowConnectorLine = true;
                labelTemplate = GetAdornmentTemplate(); //Application.Current.Resources["PieLabelTemplate"] as DataTemplate
                if (labelTemplate != null) adornment.LabelTemplate = labelTemplate;

                var series = new PieSeries
                {
                    ItemsSource = BuilModel(),
                    XBindingPath = "Country",
                    YBindingPath = "Count",
                    Label = "series " + i,
                    LabelPosition = CircularSeriesLabelPosition.Inside,
                    EnableSmartLabels = true,
                    AdornmentsInfo = adornment

                };

                Series.Add(series);
                series.Loaded += series_Loaded;
            }
        }

        private DataTemplate GetAdornmentTemplate()
        {
            var template = new DataTemplate();
            var txtblock = new FrameworkElementFactory(typeof(TextBlock));

            txtblock.SetValue(TextBlock.ForegroundProperty, new SolidColorBrush(Colors.Black));
            txtblock.SetValue(TextBlock.BackgroundProperty, new SolidColorBrush(Colors.White));
            txtblock.SetValue(TextBlock.FontSizeProperty, 8.0);
            txtblock.SetBinding(TextBlock.TextProperty, new Binding("YData"));
            
            var grid = new FrameworkElementFactory(typeof(Grid));
            grid.AppendChild(txtblock);
            template.VisualTree = grid;

            return template;
        }

        
        void series_Loaded(object sender, RoutedEventArgs e)
        {
            HelperClass.Changed(sender);
        }

        public List<Model> BuilModel()
        {
            var modelValues = new List<Model>
                    {
                        RamdomModel(),
                        RamdomModel(),
                        RamdomModel(),
                        RamdomModel(),
                        RamdomModel(),
                        RamdomModel() 
                    };
            return modelValues;
        }

        private Model RamdomModel()
        {
            var model = new Model { Count = _rnd.Next(50, 300) };
            switch (_rnd.Next(1, 5))
            {
                case 1:
                    model.Country = "Canada";
                    break;
                case 2:
                    model.Country = "Argentina";
                    break;
                case 3:
                    model.Country = "USA";
                    break;
                case 4:
                    model.Country = "Japan";
                    break;
                case 5:
                    model.Country = "China";
                    break;
            }

            return model;
        }
    }

    public class Model
    {
        public string Country { get; set; }
        public int Count { get; set; }
    }
}
